# Class ActionManager

java.lang.Object
org.jmol.viewer.ActionManager

All Implemented Interfaces:
  `EventManager`

Direct Known Subclasses:
  `ActionManagerMT`

public class ActionManager extends Object implements EventManager

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ACTION_assignNew`
`static final int`
`ACTION_center`
`static final int`
`ACTION_clickFrank`
`static final int`
`ACTION_connectAtoms`
`static final int`
`ACTION_count`
`static final int`
`ACTION_deleteAtom`
`static final int`
`ACTION_deleteBond`
`static final int`
`ACTION_depth`
`static final int`
`ACTION_dragAtom`
`static final int`
`ACTION_dragDrawObject`
`static final int`
`ACTION_dragDrawPoint`
`static final int`
`ACTION_dragLabel`
`static final int`
`ACTION_dragMinimize`
`static final int`
`ACTION_dragMinimizeMolecule`
`static final int`
`ACTION_dragSelected`
`static final int`
`ACTION_dragZ`
`static final int`
`ACTION_multiTouchSimulation`
`static final int`
`ACTION_navTranslate`
`static final int`
`ACTION_pickAtom`
`static final int`
`ACTION_pickIsosurface`
`static final int`
`ACTION_pickLabel`
`static final int`
`ACTION_pickMeasure`
`static final int`
`ACTION_pickNavigate`
`static final int`
`ACTION_pickPoint`
`static final int`
`ACTION_popupMenu`
`static final int`
`ACTION_reset`
`static final int`
`ACTION_rotate`
`static final int`
`ACTION_rotateBranch`
`static final int`
`ACTION_rotateSelected`
`static final int`
`ACTION_rotateZ`
`static final int`
`ACTION_rotateZorZoom`
`static final int`
`ACTION_select`
`static final int`
`ACTION_selectAndDrag`
`static final int`
`ACTION_selectAndNot`
`static final int`
`ACTION_selectNone`
`static final int`
`ACTION_selectOr`
`static final int`
`ACTION_selectToggle`
`static final int`
`ACTION_selectToggleExtended`
`static final int`
`ACTION_setMeasure`
`static final int`
`ACTION_slab`
`static final int`
`ACTION_slabAndDepth`
`static final int`
`ACTION_slideZoom`
`static final int`
`ACTION_spinDrawObjectCCW`
`static final int`
`ACTION_spinDrawObjectCW`
`static final int`
`ACTION_stopMotion`
`static final int`
`ACTION_swipe`
`static final int`
`ACTION_translate`
`static final int`
`ACTION_wheelZoom`
`Binding`
`b`
`protected MouseState`
`clicked`
`protected int`
`clickedCount`
`protected MouseState`
`current`
`static final float`
`DEFAULT_GESTURE_SWIPE_FACTOR`
`static final float`
`DEFAULT_MOUSE_DRAG_FACTOR`
`static final float`
`DEFAULT_MOUSE_WHEEL_FACTOR`
`protected MouseState`
`dragged`
`protected boolean`
`haveMultiTouchInput`
`protected Thread`
`hoverWatcherThread`
`protected boolean`
`isMultiTouch`
`protected boolean`
`isMultiTouchClient`
`protected boolean`
`isMultiTouchServer`
`protected static final long`
`MININUM_GESTURE_DELAY_MILLISECONDS`
`protected float`
`mouseDragFactor`
`protected float`
`mouseWheelFactor`
`protected MouseState`
`moved`
`static final int`
`PICKING_ASSIGN_ATOM`
`static final int`
`PICKING_ASSIGN_BOND`
`static final int`
`PICKING_CENTER`
`static final int`
`PICKING_CONNECT`
`static final int`
`PICKING_DELETE_ATOM`
`static final int`
`PICKING_DELETE_BOND`
`static final int`
`PICKING_DRAG_ATOM`
`static final int`
`PICKING_DRAG_LIGAND`
`static final int`
`PICKING_DRAG_MINIMIZE`
`static final int`
`PICKING_DRAG_MINIMIZE_MOLECULE`
`static final int`
`PICKING_DRAG_MODEL`
`static final int`
`PICKING_DRAG_MOLECULE`
`static final int`
`PICKING_DRAG_SELECTED`
`static final int`
`PICKING_DRAG_SPIN`
`static final int`
`PICKING_DRAW`
`static final int`
`PICKING_IDENTIFY`
`static final int`
`PICKING_IDENTIFY_BOND`
`static final int`
`PICKING_INVERT_STEREO`
`static final int`
`PICKING_LABEL`
`static final int`
`PICKING_MEASURE`
`static final int`
`PICKING_MEASURE_ANGLE`
`static final int`
`PICKING_MEASURE_DISTANCE`
`static final int`
`PICKING_MEASURE_SEQUENCE`
`static final int`
`PICKING_MEASURE_TORSION`
`static final int`
`PICKING_MK_RESET`
`static final int`
`PICKING_NAVIGATE`
`static final int`
`PICKING_OFF`
`static final int`
`PICKING_ROTATE_BOND`
`static final int`
`PICKING_SELECT_ATOM`
`static final int`
`PICKING_SELECT_CHAIN`
`static final int`
`PICKING_SELECT_ELEMENT`
`static final int`
`PICKING_SELECT_GROUP`
`static final int`
`PICKING_SELECT_MODEL`
`static final int`
`PICKING_SELECT_MOLECULE`
`static final int`
`PICKING_SELECT_POLYMER`
`static final int`
`PICKING_SELECT_SITE`
`static final int`
`PICKING_SELECT_SPIN`
`static final int`
`PICKING_SELECT_STRUCTURE`
`static final int`
`PICKING_SPIN`
`static final int`
`PICKING_STRUTS`
`static final int`
`PICKING_SYMMETRY`
`static final int`
`PICKING_SYMOP`
`static final int`
`PICKINGSTYLE_MEASURE_OFF`
`static final int`
`PICKINGSTYLE_MEASURE_ON`
`static final int`
`PICKINGSTYLE_SELECT_CHIME`
`static final int`
`PICKINGSTYLE_SELECT_DRAG`
`static final int`
`PICKINGSTYLE_SELECT_JMOL`
picking styles
`static final int`
`PICKINGSTYLE_SELECT_PFAAT`
`static final int`
`PICKINGSTYLE_SELECT_RASMOL`
`protected MouseState`
`pressed`
`protected int`
`pressedCount`
`protected Viewer`
`vwr`
`static final int`
`XY_RANGE`
`boolean`
`zoomTrigger`

## Constructor Summary

Constructors
Constructor
Description
`ActionManager()`

## Method Summary

Modifier and Type
Method
Description
`void`
`checkHover()`
`void`
`clear()`
`protected void`
`clearBindings()`
`protected void`
`clearMouseInfo()`
`void`
`dispose()`
`void`
`exitMeasurementMode(String refreshWhy)`
`static int`
`getActionFromName(String name)`
`static String`
`getActionName(int i)`
`int`
`getAtomPickingMode()`
`String`
`getBindingInfo(String qualifiers)`
`int`
`getBondPickingMode()`
`protected float`
`getDegrees(float delta, boolean isX)`
Transform a screen pixel change to an angular change such that a full sweep of the dimension (up to 500 pixels) corresponds to 180 degrees of rotation.
`static final int`
`getPickingMode(String str)`
`static final String`
`getPickingModeName(int pickingMode)`
`String`
`getPickingState()`
`static final int`
`getPickingStyleIndex(String str)`
`static final String`
`getPickingStyleName(int pickingStyle)`
`boolean`
`isHoverable()`
`boolean`
`isMTClient()`
`boolean`
`isMTServer()`
`boolean`
`keyPressed(int key, int modifiers)`
called by MouseManager.keyPressed
`void`
`keyReleased(int key)`
`boolean`
`keyTyped(int keyChar, int modifiers)`
`void`
`mouseAction(int mode, long time, int x, int y, int count, int buttonMods)`
`void`
`mouseEnterExit(long time, int x, int y, boolean isExit)`
`void`
`processMultitouchEvent(int groupID, int eventType, int touchID, int iData, P3 pt, long time)`
Specific to ActionManagerMT -- for processing SparshUI gestures
`protected void`
`setBinding(Binding newBinding)`
`protected void`
`setCurrent(long time, int x, int y, int mods)`
`void`
`setDragAtomIndex(int iatom)`
`void`
`setModeMouse(int modeMouse)`
only NONE (-1) is implemented; it just stops the hoverWatcher thread so that the vwr references are all removed
`protected void`
`setMotion(int cursor, boolean inMotion)`
`void`
`setMouseMode()`
`void`
`setPickingMode(int pickingMode)`
`void`
`setViewer(Viewer vwr, String commandOptions)`
`void`
`startHoverWatcher(boolean isStart)`
`boolean`
`userAction(int action, Object[] params)`
If the user has created a function to handle this action, run it and cancel action processing if that function returns an explicit FALSE;
`boolean`
`userActionEnabled(int action)`
`protected void`
`zoomByFactor(int dz, int x, int y)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### vwr

protected Viewer vwr

### haveMultiTouchInput

protected boolean haveMultiTouchInput

### isMultiTouch

protected boolean isMultiTouch

### b

public Binding b

### current

protected MouseState current

### moved

protected MouseState moved

### clicked

protected MouseState clicked

### pressed

protected MouseState pressed

### dragged

protected MouseState dragged

### hoverWatcherThread

protected Thread hoverWatcherThread

### ACTION_assignNew

public static final int ACTION_assignNew

See Also:
  - Constant Field Values

### ACTION_center

public static final int ACTION_center

See Also:
  - Constant Field Values

### ACTION_clickFrank

public static final int ACTION_clickFrank

See Also:
  - Constant Field Values

### ACTION_connectAtoms

public static final int ACTION_connectAtoms

See Also:
  - Constant Field Values

### ACTION_deleteAtom

public static final int ACTION_deleteAtom

See Also:
  - Constant Field Values

### ACTION_deleteBond

public static final int ACTION_deleteBond

See Also:
  - Constant Field Values

### ACTION_depth

public static final int ACTION_depth

See Also:
  - Constant Field Values

### ACTION_dragAtom

public static final int ACTION_dragAtom

See Also:
  - Constant Field Values

### ACTION_dragDrawObject

public static final int ACTION_dragDrawObject

See Also:
  - Constant Field Values

### ACTION_dragDrawPoint

public static final int ACTION_dragDrawPoint

See Also:
  - Constant Field Values

### ACTION_dragLabel

public static final int ACTION_dragLabel

See Also:
  - Constant Field Values

### ACTION_dragMinimize

public static final int ACTION_dragMinimize

See Also:
  - Constant Field Values

### ACTION_dragMinimizeMolecule

public static final int ACTION_dragMinimizeMolecule

See Also:
  - Constant Field Values

### ACTION_dragSelected

public static final int ACTION_dragSelected

See Also:
  - Constant Field Values

### ACTION_dragZ

public static final int ACTION_dragZ

See Also:
  - Constant Field Values

### ACTION_multiTouchSimulation

public static final int ACTION_multiTouchSimulation

See Also:
  - Constant Field Values

### ACTION_navTranslate

public static final int ACTION_navTranslate

See Also:
  - Constant Field Values

### ACTION_pickAtom

public static final int ACTION_pickAtom

See Also:
  - Constant Field Values

### ACTION_pickIsosurface

public static final int ACTION_pickIsosurface

See Also:
  - Constant Field Values

### ACTION_pickLabel

public static final int ACTION_pickLabel

See Also:
  - Constant Field Values

### ACTION_pickMeasure

public static final int ACTION_pickMeasure

See Also:
  - Constant Field Values

### ACTION_pickNavigate

public static final int ACTION_pickNavigate

See Also:
  - Constant Field Values

### ACTION_pickPoint

public static final int ACTION_pickPoint

See Also:
  - Constant Field Values

### ACTION_popupMenu

public static final int ACTION_popupMenu

See Also:
  - Constant Field Values

### ACTION_reset

public static final int ACTION_reset

See Also:
  - Constant Field Values

### ACTION_rotate

public static final int ACTION_rotate

See Also:
  - Constant Field Values

### ACTION_rotateBranch

public static final int ACTION_rotateBranch

See Also:
  - Constant Field Values

### ACTION_rotateSelected

public static final int ACTION_rotateSelected

See Also:
  - Constant Field Values

### ACTION_rotateZ

public static final int ACTION_rotateZ

See Also:
  - Constant Field Values

### ACTION_rotateZorZoom

public static final int ACTION_rotateZorZoom

See Also:
  - Constant Field Values

### ACTION_select

public static final int ACTION_select

See Also:
  - Constant Field Values

### ACTION_selectAndDrag

public static final int ACTION_selectAndDrag

See Also:
  - Constant Field Values

### ACTION_selectAndNot

public static final int ACTION_selectAndNot

See Also:
  - Constant Field Values

### ACTION_selectNone

public static final int ACTION_selectNone

See Also:
  - Constant Field Values

### ACTION_selectOr

public static final int ACTION_selectOr

See Also:
  - Constant Field Values

### ACTION_selectToggle

public static final int ACTION_selectToggle

See Also:
  - Constant Field Values

### ACTION_selectToggleExtended

public static final int ACTION_selectToggleExtended

See Also:
  - Constant Field Values

### ACTION_setMeasure

public static final int ACTION_setMeasure

See Also:
  - Constant Field Values

### ACTION_slab

public static final int ACTION_slab

See Also:
  - Constant Field Values

### ACTION_slabAndDepth

public static final int ACTION_slabAndDepth

See Also:
  - Constant Field Values

### ACTION_slideZoom

public static final int ACTION_slideZoom

See Also:
  - Constant Field Values

### ACTION_spinDrawObjectCCW

public static final int ACTION_spinDrawObjectCCW

See Also:
  - Constant Field Values

### ACTION_spinDrawObjectCW

public static final int ACTION_spinDrawObjectCW

See Also:
  - Constant Field Values

### ACTION_stopMotion

public static final int ACTION_stopMotion

See Also:
  - Constant Field Values

### ACTION_swipe

public static final int ACTION_swipe

See Also:
  - Constant Field Values

### ACTION_translate

public static final int ACTION_translate

See Also:
  - Constant Field Values

### ACTION_wheelZoom

public static final int ACTION_wheelZoom

See Also:
  - Constant Field Values

### ACTION_count

public static final int ACTION_count

See Also:
  - Constant Field Values

### PICKING_MK_RESET

public static final int PICKING_MK_RESET

See Also:
  - Constant Field Values

### PICKING_OFF

public static final int PICKING_OFF

See Also:
  - Constant Field Values

### PICKING_IDENTIFY

public static final int PICKING_IDENTIFY

See Also:
  - Constant Field Values

### PICKING_LABEL

public static final int PICKING_LABEL

See Also:
  - Constant Field Values

### PICKING_CENTER

public static final int PICKING_CENTER

See Also:
  - Constant Field Values

### PICKING_DRAW

public static final int PICKING_DRAW

See Also:
  - Constant Field Values

### PICKING_SPIN

public static final int PICKING_SPIN

See Also:
  - Constant Field Values

### PICKING_SYMMETRY

public static final int PICKING_SYMMETRY

See Also:
  - Constant Field Values

### PICKING_DELETE_ATOM

public static final int PICKING_DELETE_ATOM

See Also:
  - Constant Field Values

### PICKING_DELETE_BOND

public static final int PICKING_DELETE_BOND

See Also:
  - Constant Field Values

### PICKING_SELECT_ATOM

public static final int PICKING_SELECT_ATOM

See Also:
  - Constant Field Values

### PICKING_SELECT_GROUP

public static final int PICKING_SELECT_GROUP

See Also:
  - Constant Field Values

### PICKING_SELECT_CHAIN

public static final int PICKING_SELECT_CHAIN

See Also:
  - Constant Field Values

### PICKING_SELECT_MOLECULE

public static final int PICKING_SELECT_MOLECULE

See Also:
  - Constant Field Values

### PICKING_SELECT_POLYMER

public static final int PICKING_SELECT_POLYMER

See Also:
  - Constant Field Values

### PICKING_SELECT_STRUCTURE

public static final int PICKING_SELECT_STRUCTURE

See Also:
  - Constant Field Values

### PICKING_SELECT_SITE

public static final int PICKING_SELECT_SITE

See Also:
  - Constant Field Values

### PICKING_SELECT_MODEL

public static final int PICKING_SELECT_MODEL

See Also:
  - Constant Field Values

### PICKING_SELECT_ELEMENT

public static final int PICKING_SELECT_ELEMENT

See Also:
  - Constant Field Values

### PICKING_MEASURE

public static final int PICKING_MEASURE

See Also:
  - Constant Field Values

### PICKING_MEASURE_DISTANCE

public static final int PICKING_MEASURE_DISTANCE

See Also:
  - Constant Field Values

### PICKING_MEASURE_ANGLE

public static final int PICKING_MEASURE_ANGLE

See Also:
  - Constant Field Values

### PICKING_MEASURE_TORSION

public static final int PICKING_MEASURE_TORSION

See Also:
  - Constant Field Values

### PICKING_MEASURE_SEQUENCE

public static final int PICKING_MEASURE_SEQUENCE

See Also:
  - Constant Field Values

### PICKING_NAVIGATE

public static final int PICKING_NAVIGATE

See Also:
  - Constant Field Values

### PICKING_CONNECT

public static final int PICKING_CONNECT

See Also:
  - Constant Field Values

### PICKING_STRUTS

public static final int PICKING_STRUTS

See Also:
  - Constant Field Values

### PICKING_DRAG_SELECTED

public static final int PICKING_DRAG_SELECTED

See Also:
  - Constant Field Values

### PICKING_DRAG_MOLECULE

public static final int PICKING_DRAG_MOLECULE

See Also:
  - Constant Field Values

### PICKING_DRAG_ATOM

public static final int PICKING_DRAG_ATOM

See Also:
  - Constant Field Values

### PICKING_DRAG_MINIMIZE

public static final int PICKING_DRAG_MINIMIZE

See Also:
  - Constant Field Values

### PICKING_DRAG_MINIMIZE_MOLECULE

public static final int PICKING_DRAG_MINIMIZE_MOLECULE

See Also:
  - Constant Field Values

### PICKING_INVERT_STEREO

public static final int PICKING_INVERT_STEREO

See Also:
  - Constant Field Values

### PICKING_ASSIGN_ATOM

public static final int PICKING_ASSIGN_ATOM

See Also:
  - Constant Field Values

### PICKING_ASSIGN_BOND

public static final int PICKING_ASSIGN_BOND

See Also:
  - Constant Field Values

### PICKING_ROTATE_BOND

public static final int PICKING_ROTATE_BOND

See Also:
  - Constant Field Values

### PICKING_IDENTIFY_BOND

public static final int PICKING_IDENTIFY_BOND

See Also:
  - Constant Field Values

### PICKING_DRAG_LIGAND

public static final int PICKING_DRAG_LIGAND

See Also:
  - Constant Field Values

### PICKING_DRAG_MODEL

public static final int PICKING_DRAG_MODEL

See Also:
  - Constant Field Values

### PICKING_SYMOP

public static final int PICKING_SYMOP

See Also:
  - Constant Field Values

### PICKING_SELECT_SPIN

public static final int PICKING_SELECT_SPIN

See Also:
  - Constant Field Values

### PICKING_DRAG_SPIN

public static final int PICKING_DRAG_SPIN

See Also:
  - Constant Field Values

### PICKINGSTYLE_SELECT_JMOL

public static final int PICKINGSTYLE_SELECT_JMOL
picking styles

See Also:
  - Constant Field Values

### PICKINGSTYLE_SELECT_CHIME

public static final int PICKINGSTYLE_SELECT_CHIME

See Also:
  - Constant Field Values

### PICKINGSTYLE_SELECT_RASMOL

public static final int PICKINGSTYLE_SELECT_RASMOL

See Also:
  - Constant Field Values

### PICKINGSTYLE_SELECT_PFAAT

public static final int PICKINGSTYLE_SELECT_PFAAT

See Also:
  - Constant Field Values

### PICKINGSTYLE_SELECT_DRAG

public static final int PICKINGSTYLE_SELECT_DRAG

See Also:
  - Constant Field Values

### PICKINGSTYLE_MEASURE_ON

public static final int PICKINGSTYLE_MEASURE_ON

See Also:
  - Constant Field Values

### PICKINGSTYLE_MEASURE_OFF

public static final int PICKINGSTYLE_MEASURE_OFF

See Also:
  - Constant Field Values

### MININUM_GESTURE_DELAY_MILLISECONDS

protected static final long MININUM_GESTURE_DELAY_MILLISECONDS

See Also:
  - Constant Field Values

### DEFAULT_MOUSE_DRAG_FACTOR

public static final float DEFAULT_MOUSE_DRAG_FACTOR

See Also:
  - Constant Field Values

### DEFAULT_MOUSE_WHEEL_FACTOR

public static final float DEFAULT_MOUSE_WHEEL_FACTOR

See Also:
  - Constant Field Values

### DEFAULT_GESTURE_SWIPE_FACTOR

public static final float DEFAULT_GESTURE_SWIPE_FACTOR

See Also:
  - Constant Field Values

### XY_RANGE

public static final int XY_RANGE

See Also:
  - Constant Field Values

### mouseDragFactor

protected float mouseDragFactor

### mouseWheelFactor

protected float mouseWheelFactor

### pressedCount

protected int pressedCount

### clickedCount

protected int clickedCount

### isMultiTouchClient

protected boolean isMultiTouchClient

### isMultiTouchServer

protected boolean isMultiTouchServer

### zoomTrigger

public boolean zoomTrigger

## Constructor Details

### ActionManager

public ActionManager()

## Method Details

### setViewer

public void setViewer(Viewer vwr, String commandOptions)

Parameters:
  `vwr` -
  `commandOptions` -

### isHoverable

public boolean isHoverable()

### checkHover

public void checkHover()

### processMultitouchEvent

public void processMultitouchEvent(int groupID, int eventType, int touchID, int iData, P3 pt, long time)
Specific to ActionManagerMT -- for processing SparshUI gestures

Parameters:
  `groupID` -
  `eventType` -
  `touchID` -
  `iData` -
  `pt` -
  `time` -

### clearBindings

protected void clearBindings()

### getActionName

public static String getActionName(int i)

### getActionFromName

public static int getActionFromName(String name)

### getBindingInfo

public String getBindingInfo(String qualifiers)

### setBinding

protected void setBinding(Binding newBinding)

### getBondPickingMode

public int getBondPickingMode()

### getPickingModeName

public static final String getPickingModeName(int pickingMode)

### getPickingMode

public static final int getPickingMode(String str)

### getPickingStyleName

public static final String getPickingStyleName(int pickingStyle)

### getPickingStyleIndex

public static final int getPickingStyleIndex(String str)

### getAtomPickingMode

public int getAtomPickingMode()

### setPickingMode

public void setPickingMode(int pickingMode)

### getPickingState

public String getPickingState()

### setCurrent

protected void setCurrent(long time, int x, int y, int mods)

### setMouseMode

public void setMouseMode()

### clearMouseInfo

protected void clearMouseInfo()

### setDragAtomIndex

public void setDragAtomIndex(int iatom)

### isMTClient

public boolean isMTClient()

### isMTServer

public boolean isMTServer()

### dispose

public void dispose()

### clear

public void clear()

### startHoverWatcher

public void startHoverWatcher(boolean isStart)

### setModeMouse

public void setModeMouse(int modeMouse)
only NONE (-1) is implemented; it just stops the hoverWatcher thread so that the vwr references are all removed

Parameters:
  `modeMouse` -

### keyPressed

public boolean keyPressed(int key, int modifiers)
called by MouseManager.keyPressed

Specified by:
  `keyPressed` in interface `EventManager`
Parameters:
  `key` -
  `modifiers` -
Returns:
  true if handled

### keyTyped

public boolean keyTyped(int keyChar, int modifiers)

Specified by:
  `keyTyped` in interface `EventManager`

### keyReleased

public void keyReleased(int key)

Specified by:
  `keyReleased` in interface `EventManager`

### mouseEnterExit

public void mouseEnterExit(long time, int x, int y, boolean isExit)

Specified by:
  `mouseEnterExit` in interface `EventManager`

### mouseAction

public void mouseAction(int mode, long time, int x, int y, int count, int buttonMods)

Specified by:
  `mouseAction` in interface `EventManager`
Parameters:
  `mode` - MOVED PRESSED DRAGGED RELEASED CLICKED WHEELED
  `time` -
  `x` -
  `y` -
  `count` -
  `buttonMods` - LEFT RIGHT MIDDLE WHEEL SHIFT ALT CTRL

### getDegrees

protected float getDegrees(float delta, boolean isX)
Transform a screen pixel change to an angular change such that a full sweep of the dimension (up to 500 pixels) corresponds to 180 degrees of rotation.

Parameters:
  `delta` -
  `isX` -
Returns:
  desired scaled rotation, in degrees

### exitMeasurementMode

public void exitMeasurementMode(String refreshWhy)

### setMotion

protected void setMotion(int cursor, boolean inMotion)

### zoomByFactor

protected void zoomByFactor(int dz, int x, int y)

### userActionEnabled

public boolean userActionEnabled(int action)

### userAction

public boolean userAction(int action, Object[] params)
If the user has created a function to handle this action, run it and cancel action processing if that function returns an explicit FALSE;

Parameters:
  `action` -
  `params` -
Returns:
  true to continue with the standard action